program Manhattan (input, output);

{ versie om vraagstuk te bedenken }

const
   max = 250;

type
   rooster = array[1..max, 1..max] of integer;
   tabel = array[1..max, 1..2] of integer;

var   { alles globaal }
   stad, nsteden,            { run-variabelen }
   n,                        { aantal avenues }
   m,                        { aantal lanes }
   nkruisingen : integer;    { aantal kruisingen }
   index, minimum : rooster;
   adjacency : tabel;


procedure leesRooster;
{ lees rooster en genereer index-tabel }

var
   ch	: char;
   i, j	: integer;

begin
   read(n);
   readln(m);
   nkruisingen := 0;
   for i := 1 to n do begin
      for j := 1 to m do begin
	 read(ch);
	 if ch='x' then begin
	    index[i, j] := 0;
	 end else begin { ch = '+' }
	    nkruisingen := nkruisingen+1;
	    index[i, j] := nkruisingen;
	 end;
      end;
      readln;
   end;
   writeln('#kruisingen=', nkruisingen:1);
end; { leesRooster }


procedure genereerAdjacency;
{ genereer adjacency-tabel }

var
   i, j, c : integer;

begin
   for i := 0 to ((n-1) div 2) do
      for j := 1 to (m-1) do begin
	 c := index[2*i+1, j];
	 if c>0 then adjacency[c, 1] := index[2*i+1, j+1];
      end;
   for i := 1 to (n div 2) do
      for j := 2 to m do begin
	 c := index[2*i, j];
	 if c>0 then adjacency[c, 1] := index[2*i, j-1];
      end;
   for j := 0 to ((m-1) div 2) do
      for i := 1 to (n-1) do begin
	 c := index[i, 2*j+1];
	 if c>0 then adjacency[c, 2] := index[i+1, 2*j+1];
      end;
   for j := 1 to (m div 2) do
      for i := 2 to n do begin
	 c := index[i, 2*j];
	 if c>0 then adjacency[c, 2] := index[i-1, 2*j];
      end;
end; { genereerAdj }


procedure bezoekKruisingen;
{ ga alle bereikbare kruisingen af: alle-paren kortste pad }

type
   queue = array[1..max] of integer;

var
   Q : queue;
   u, v, stap, naar : integer;
   beginQ, { index begin queue }
   eindQ,  { index einde queue }
   lengteQ { lengte nieuwe queue } : integer;

begin
   for u := 1 to nkruisingen do begin
      { initialiseer rij van de minimum-matrix }
      for v := 1 to nkruisingen do begin
	 minimum[u, v] := 0;
      end;
      { initialiseer queue door huidige kruisingen erop te plaatsen }
      stap := 0;
      beginQ := 1;
      eindQ := 1;
      lengteQ := 1;
      Q[1] := u;
      while lengteQ > 0 do begin
	 lengteQ := 0;
	 stap := stap+1;
	 for v := beginQ to eindQ do begin
	    { haal kruising van de queue en ga naar "adjacent" kruisingen }
	    naar := adjacency[Q[v], 1];
	    if (naar > 0) and (minimum[u, naar] = 0) then begin
	       minimum[u, naar] := stap;
	       lengteQ := lengteQ+1;
	       Q[eindQ+lengteQ] := naar;
	    end;
	    naar := adjacency[Q[v], 2];
	    if (naar > 0) and (minimum[u, naar] = 0) then begin
	       minimum[u, naar] := stap;
	       lengteQ := lengteQ+1;
	       Q[eindQ+lengteQ] := naar;
	    end;
	 end;
	 { verplaats queue-indices }
	 beginQ := eindQ + 1;
	 eindQ := beginQ + lengteQ - 1;
      end;
   end;
end; { bezoekKruisingen }


procedure schrijfMinimum;
{ schrijf minimum }

var
   u, v : integer;

begin
   writeln('min:');
   for u := 1 to nkruisingen do begin
      for v := 1 to nkruisingen do begin
	 write(' ', minimum[u, v]:1, ' ');
      end;
      writeln;
   end;
end; { schrijfMinimum }


function rounddiv (x, y : integer) : integer;
{ geeft x rounddiv y terug }

var
   d, m : integer;

begin
   d := x div y;
   m := x mod y;
   if 2*m>=y then begin
      rounddiv := d + 1;
   end else begin
      rounddiv := d;
   end;
end; { rounddiv }


procedure schrijfGemiddelden;
{ schrijf de matrix van gemiddelden terug }

var
   i, j, k, waar, som, aantal : integer;

begin
   writeln('<>:');
   for i := 1 to n do begin
      for j := 1 to m do begin
	 if index[i, j]=0 then begin
	    write(' xxxxx ');
	 end else begin
	    waar := index[i, j];
	    som := 0;
	    aantal := 0;
	    for k := 1 to nkruisingen do begin
	       if minimum[k, waar]<>0 then begin
		  aantal := aantal+1;
		  som := som + minimum[k, waar];
	       end;
	    end;
	    if aantal<>0 then begin
	       write(' ', (som/aantal):5:1, ' ');
	    end else begin
	       write(' ##### ');
	    end;
	 end;
      end;
      writeln;
   end;
end; { schrijfGemiddelden }


begin
   readln(nsteden);
   for stad := 1 to nsteden do begin
      leesRooster;
      genereerAdjacency;
      bezoekKruisingen;
      schrijfMinimum;
      schrijfGemiddelden;
      if stad<nsteden then begin
	 writeln;
      end;
   end;
end.
