/* uitwerking van Minkowski-som, NKP 1997, Ivor */

#include "stdio.h"
#define MAXINT 1000000
	
int aantal[2];
int listx[3][1000000];
int listy[3][1000000];

float rc(int x,int y) {
	/* geef het richtingscoefficient van (x,y) */
	if (x==0) {
        if (y==0) {
          return((float)MAXINT);
        } else {
          return((float)-MAXINT);
        }
      } else {
        return((float)(y/x));
      }
    }

int quadrant(x,y) {
	/* in welk quadrant ligt (x,y) ? */
    if (x>0) {
		return(3*(y<0));
    } else {
        return(1+(y<0));
    }
}

int hoekkleiner(int x1,int y1,int x2,int y2) {
    /* is de hoek van (x1,y1) < (y1,y2) */
    int t1,t2;

    if ( (t1=quadrant(x1,y1))!=(t2=quadrant(x2,y2)) ) {
        return(t1<t2);
    } else {
        return(rc(x1,y1)<rc(x2,y2));
    }
}

void main() {

  int k,keer,m,x1,x2,y1,y2;
  int p0,p1,p2,i;

  scanf("%d",&keer);
  for (k=0;k<keer;k++) {
    for(m=0;m<2;m++) {
      scanf("%d",&aantal[m]);
      for (i=0;i<aantal[m];i++) {
	scanf("%d %d",&listx[m][i],&listy[m][i]);
      }
    }
    p0=p1=p2=0;
    while ((p0<aantal[0]) && (p1<aantal[1])) {
      listx[2][p2]=listx[0][p0]+listx[1][p1];
      listy[2][p2++]=listy[0][p0]+listy[1][p1];
      
      x1=listx[0][((p0+1)%aantal[0])]-listx[0][p0];
      y1=listy[0][((p0+1)%aantal[0])]-listy[0][p0];
      x2=listx[1][((p1+1)%aantal[1])]-listx[1][p1];
      y2=listy[1][((p1+1)%aantal[1])]-listy[1][p1];
      
      if (hoekkleiner(x1,y1,
		      x2,y2)) {
	p0++;
      } else {
	p1++;
      }
    }
    while (p0<aantal[0]) {
      listx[2][p2]=listx[1][p1]+listx[0][p0];
      listy[2][p2++]=listy[1][p1]+listy[0][p0++];
    }
    while (p1<aantal[1]) {
      listx[2][p2]=listx[0][p0]+listx[1][p1];
      listy[2][p2++]=listy[0][p0]+listy[1][p1++];
    }
    printf("%d\n",p2);
    for (m=0;m<p2;m++) {
      printf("%d %d  ",listx[2][m],listy[2][m]);
    }
    printf("\n");
  }
}
