Program Minkowsky(input,output);

const
  maxv=10001;

type
  vertex=record
    x,y:integer;
  end;
  vertexarray=array[1..maxv] of vertex;
  vector=record
    region:integer;
    dx,dy:integer;
  end;
  vectorarray=array[1..maxv] of vector;

var
  run,runs:integer;
  c1,c2,c3:integer;
  i1,i2,i3:integer;
  v3:vertexarray;
  vec1,vec2:vectorarray;
  comp:integer;

Function Compare(vec1,vec2:vector):integer;
var
  result:integer;
begin
  result:=vec2.region-vec1.region;
  if (result=0) then result:=vec2.dy*vec1.dx-vec1.dy*vec2.dx;
  Compare:=result;
end; { Compare }

Procedure ReadPolygon(var c:integer;var vec:vectorarray);
var
  v1,prev,v:vertex;
  i:integer;
begin
  ReadLn(c);
  Read(v1.x,v1.y);
  v:=v1;
  prev:=v1;
  for i:=1 to c-1 do begin
    Read(v.x,v.y);
    vec[i].dx:=v.x-prev.x;
    vec[i].dy:=v.y-prev.y;
    prev:=v;
  end;
  vec[c].dx:=v1.x-v.x;
  vec[c].dy:=v1.y-v.y;
  for i:=1 to c do begin
    if (vec[i].dy>0) or ((vec[i].dy>=0) and (vec[i].dx>0))
      then vec[i].region:=1 else vec[i].region:=2;
  end;
  v3[1].x:=v3[1].x+v1.x; (* Major *)
  v3[1].y:=v3[1].y+v1.y; (* Side effect *)
  vec[c+1].region:=3; (* Sentinel *)
end; { ReadPolygon }


begin { Minkowsky }
  ReadLn(runs);
  for run:=1 to runs do begin
    v3[1].x:=0;
    v3[1].y:=0;
    ReadPolygon(c1,vec1);
    ReadPolygon(c2,vec2);

    i1:=1;
    i2:=1;
    c3:=1;
    while (i1<=c1) or (i2<=c2) do begin
(*  WriteLn(i1:1,';',i2:1,';',c3:1,
            ' (',vec1[i1].region:1,':',vec1[i1].dx:1,',',vec1[i1].dy:1,
	    ') (',vec2[i2].region:1,':',vec2[i2].dx:1,',',vec2[i2].dy:1,')'); *)
      c3:=c3+1;
      comp:=Compare(vec1[i1],vec2[i2]);
      if (comp>0) then begin
        v3[c3].x:=v3[c3-1].x+vec1[i1].dx;
        v3[c3].y:=v3[c3-1].y+vec1[i1].dy;
        i1:=i1+1;
      end else begin
        if (comp<0) then begin
          v3[c3].x:=v3[c3-1].x+vec2[i2].dx;
          v3[c3].y:=v3[c3-1].y+vec2[i2].dy;
          i2:=i2+1;
        end else begin
          v3[c3].x:=v3[c3-1].x+vec1[i1].dx+vec2[i2].dx;
          v3[c3].y:=v3[c3-1].y+vec1[i1].dy+vec2[i2].dy;
          i1:=i1+1;
          i2:=i2+1;
        end
      end;
    end;
    WriteLn(c3-1:1);
    for i3:=1 to c3-1 do begin
      Write(v3[i3].x:1,' ',v3[i3].y:1);
      if (i3=c3-1) then WriteLn else Write('  ');
    end;
  end;
end. { Minkowsky }
