program Riemann (input, output);

{ (c) 07/08/'97 Meinte Boersma
  Pascal-uitwerking van de NKP'97-opgave "Riemann"
}

const
   max = 1000000;

type
   zeef = array[1..max] of integer;

var
   moebius : zeef;
   run, n, m : integer;


procedure vul (var moebius : zeef);

var
   i, som, veelvoud, kwadraat, wortel : integer;

begin
   som := 1;
   moebius[1] := 1;
   for i := 2 to max do  moebius[i] := 2;
   { I and i = 1 }

   wortel := trunc(sqrt(max));
   i := 2;

   while 2*i <= max do begin
      { vind het volgende priemgetal }
      while moebius[i]<>2 do begin
         som := som + moebius[i];
         moebius[i] := som;
         i := i + 1;
      end;

      { i is priem ==> mu(i) = -1 }
      som := som - 1;
      moebius[i] := som;
      { 1e zeefstap: veelvouden van de priem i "omklappen" }
      veelvoud := 2*i;
      while veelvoud <= max do begin
         if moebius[veelvoud] = 2 then begin
            { VEELVOUD nog niet aangeraakt }
            moebius[veelvoud] := -1;
         end else begin
            { "omklappen", want er komt een priem bij }
            moebius[veelvoud] := -moebius[veelvoud];
         end;
         veelvoud := veelvoud + i;
      end;
      { 2e zeefstap: veelvouden van i^2 eruit zeven }
      if i <= wortel then begin
         kwadraat := sqr(i);
         veelvoud := kwadraat;
         while veelvoud <= max do begin
            moebius[veelvoud] := 0;
            veelvoud := veelvoud + kwadraat;
         end;
      end;
      {I}
      i := i + 1;
   end;

   { rest van de zeef behandelen }
   for i := i to max do begin
      if moebius[i] = 2 then begin
         som := som - 1;
         moebius[i] := som;
      end else begin
         som := som + moebius[i];
         moebius[i] := som;
      end;
   end;
   { I and i = max ==> voor alle j: moebius[j] = mu(1) + ... + mu(j) }
end; { vul }


begin
   vul(moebius);
   readln(m);
   for run := 1 to m do begin
      readln(n);
      writeln(abs(moebius[n]):1);
   end;
end.
