program simul (input, output); {Wim H. Hesselink, 12 juni 1997}
{   Het abstracte algoritme
    R := V \times W $ ;
    repeat // invariant : Sim \subseteq R
      issim := true ;
      for all (x,y) \in R do 
        if (\ex (x,r,v) \in E ::
            \neg\, (\ex (v,w) \in R :: (y,r,w) \in F) then 
          issim := false ;
          R := R - (x,y) ;
        fi
      od 
    until issim ; // R = Sim 
Complexiteit: de forlus hierin kost tenhoogste #E * #F ;
de repeatlus vermenigvuldigt dit tenhoogste met #V * #W ;
de totale complexiteit is dus ten hoogste #V * #W * #E * #F. }

const mcard = 300 ;
type
  knoop   = 0 .. mcard ; 
  nhblist = ^ nhbcell ;
  nhbcell = record 
              lab: integer ;
              buur: knoop ;
              next: nhblist 
            end ;
  graph   = record
              card: integer ;
              ar:   array [knoop] of nhblist 
            end ;
  var g, h: graph ;
      relatie : array [knoop, knoop] of boolean ;
      r,runs: integer;

procedure push (r: integer ; y: knoop ; var p: nhblist) ;
  var q: nhblist ;
  begin
    new (q) ;
    q^.lab := r ; q^.buur := y ; q^.next := p ;
    p := q ;
  end {push} ;

procedure leesgraph (var g: graph) ;
(* Changed to conform NKP'97 style [Kero] *)
var
ch :char ;
   x, r, y: integer ;
   edges,e:integer;
begin
   ReadLn (g.card,edges) ;
   for x := 0 to g.card -1 do g.ar[x] := nil ;
   for e:=1 to edges do begin
      read (x,r,y);
      push (r, y, g.ar[x]) ;
   end;
end {leesgraph} ;
    
function isnotsim1 (r: integer; v: knoop; y: knoop) : boolean ;
  {not exists w with (v,w) in R and (y,r,w) in F}
  var t, u: nhblist ;
  begin {linear search with sentinel}
    t := h.ar[y] ; u := nil ;
    while t <> u do begin
      if (t^.lab = r) and relatie [v, t^.buur] then u := t 
      else t := t^.next ;
    end ;
    isnotsim1 := t = nil ;
  end {isnotsim1} ;

function isnotsim0 (x: knoop; y: knoop) : boolean ;
  {exists (x,r,v) such that
       not exists w with (v,w) in R and (y,r,w) in F}
  var t, u: nhblist ;
  begin {linear search with sentinel}
    t := g.ar[x] ; u := nil ;
    while t <> u do begin
      if isnotsim1 (t^.lab, t^.buur, y) then u := t 
      else t := t^.next ;
    end ;
    isnotsim0 := t <> nil ;
  end {isnotsim0} ;

procedure reducerelatie (var issim: boolean) ;
  var x, y : knoop ;
  begin
    issim := true ;
    for x := 0 to g.card - 1 do 
      for y := 0 to h.card - 1 do
        if relatie [x, y] then
          if isnotsim0 (x,y) then begin
            issim := false ;
            relatie [x,y] := false ;
          end ;
  end {reducerelatie} ;

procedure computesim ;
  var x, y : knoop ; issim : boolean ;
  begin
    for x := 0 to g.card - 1 do 
      for y := 0 to h.card - 1 do
        relatie [x, y] := true ;
    repeat
      reducerelatie (issim) ;
    until issim
  end {computesim} ;

procedure printrelatie;
(* Changed to conform NKP'97 style [Kero] *)
var
   x,y: knoop;
   first: boolean;
begin
   first:=true;
   for x := 0 to g.card - 1 do begin
      for y := 0 to h.card - 1 do begin
	 if relatie [x, y] then begin
	    if first then begin
	       first:=false;
	    end else begin
	       write('  ');
	    end;
	    write (x:1,' ',y:1);
	 end;
      end;
   end;
   writeln;
end {printrelatie};

begin {main}
   (* Changed to conform NKP'97 style [Kero] *)
   ReadLn(runs);
   for r:=1 to runs do begin
      leesgraph (g) ;
      leesgraph (h) ;
      computesim ;
      printrelatie ;
   end;
end .
