#include <stdlib.h>

#define MAXVERTICES 100000

#define false 0
#define true 1

#define wit 0
#define rood 1
#define groen 2
#define blauw 4


typedef struct intelt {
  int index;
  struct intelt *next;
} intelt;

typedef struct wereld {
  intelt *edge;
  unsigned char kleur;
  unsigned char haast; /* Hoe urgent moet deze vertex een kleur krijgen? */
  unsigned char genomineerd; /* En is deze vertex daarvoor al aangemeld? */
} wereld;

typedef struct {
  int nr[MAXVERTICES];
  unsigned int start,eind;
} queue;


unsigned int vertices,geverfd;
wereld vertex[MAXVERTICES];
queue q1,q2;


int QEmpty(queue *q) {
  return(q->start==q->eind);
}

void QPush(queue *q,int wnr) {
  q->nr[q->eind]=wnr;
  q->eind++;
}

int QPop(queue *q) {
  int result;
  if (QEmpty(q)) { /* Zou niet voor mogen komen in dit programma */
    fprintf(stderr,"Probleempje...\n");
    exit(1);
  }
  result=q->nr[q->start];
  q->start++;
  return(result);
}


void Init() {
  unsigned int buren,nr1,nr2,i;
  intelt *pie;

  scanf("%u",&vertices);
  for (i=0;i<vertices;i++) {
    vertex[i].kleur=wit;
    vertex[i].haast=wit;
    vertex[i].genomineerd=0;
    vertex[i].edge=NULL;
  }
  geverfd=0;
  scanf("%u",&buren);
  for (i=0;i<buren;i++) {
    scanf("%u %u",&nr1,&nr2);
    if (nr1>=nr2) {
      fprintf(stderr,"3-kleuren: invoer incorrect (%d voor %d)\n",nr1,nr2);
      exit(38);
    }
    pie=malloc(sizeof(intelt));
    pie->index=nr1-1;
    pie->next=vertex[nr2-1].edge;
    vertex[nr2-1].edge=pie;
    pie=malloc(sizeof(intelt));
    pie->index=nr2-1;
    pie->next=vertex[nr1-1].edge;
    vertex[nr1-1].edge=pie;
  }
  q1.start=0;
  q1.eind=0;
  q2.start=0;
  q2.eind=0;
}

void QPrint(queue *q) {
  unsigned int i;
  for (i=q->start;i<q->eind;i++) {
    fprintf(stderr,"%d ",q->nr[i]);
  }
}

void PrintWereld() {
  unsigned int i;
  for (i=0;i<vertices;i++) {
    if (i==0) fprintf(stderr,"[");
    else fprintf(stderr,",");
    fprintf(stderr,"%d",vertex[i].kleur);
  }
  fprintf(stderr,"]\n");
  QPrint(&q1);
  fprintf(stderr,"\n");
  QPrint(&q2);
  fprintf(stderr,"\n");
}

int VerfVertex(int wnr) {
  intelt *b;
  if (rood&vertex[wnr].haast) {
    if (groen&vertex[wnr].haast) {
      if (blauw&vertex[wnr].haast) {
	return(false);
      } else vertex[wnr].kleur=blauw;
    } else vertex[wnr].kleur=groen;
  } else vertex[wnr].kleur=rood;
  vertex[wnr].genomineerd=2;
  geverfd++;

  b=vertex[wnr].edge;
  while (b!=NULL) {
    vertex[b->index].haast |= vertex[wnr].kleur;
    if (vertex[b->index].haast - vertex[wnr].kleur) {
      /* Heeft ook al een anders gekleurde edge, */
      if (vertex[b->index].genomineerd<2) {
	/* is zelf nog niet gekleurd, of daarvoor genomineerd, dus: */
	QPush(&q2,b->index);
	vertex[b->index].genomineerd=2;
      }
    } else {
      if (vertex[b->index].genomineerd<1) {
	QPush(&q1,b->index);
	vertex[b->index].genomineerd=1;
      }
    }
    b=b->next;
  }
  return(true);
}

void VervenDieHap() {
  int result;
  int wnr;

  result=true;
  VerfVertex(0); /* rood */
  while ((result) && (geverfd!=vertices)) {
    /* Filter genomineerden uit Q1 die al geverfd zijn eruit */
    while (vertex[wnr=QPop(&q1)].kleur); /* Wastie leeg, dan hadden we geen connected graph */
    result=VerfVertex(wnr);
    while ((result) && (!QEmpty(&q2))) {
      result=VerfVertex(QPop(&q2));
    }
  }
  if (result) printf("mogelijk\n");
  else printf("onmogelijk\n");
}

void QuitEdge(intelt *b) {
  if (b!=NULL) {
    QuitEdge(b->next);
    free(b);
  }
}

void Quit() {
  unsigned int i;
  for (i=0;i<vertices;i++) QuitEdge(vertex[i].edge);
}

int main() {
  unsigned int runs,i;

  scanf("%u",&runs);
  for (i=0;i<runs;i++) {
    Init();
    VervenDieHap();
    Quit();
  }
  return(0);
}
