$HEAP_DISPOSE ON$
$GLOBAL 'NONE'$
Program DrieKleuren(input,output);

const
   maxvertices=100000;

type
  kleuren=(rood,groen,blauw);
  kleurset=set of kleuren;
  pintelt=^intelt;
  intelt=record
    index:integer;
    next:pintelt;
  end;
  wereld=record
    edge:pintelt;
    kleur:kleurset;
    haast:kleurset; (* Hoe urgent moet deze vertex een kleur krijgen? *)
    genomineerd:integer; (* En is hij daarvoor al aangemeld? *)
  end;

  queue=record
    nr:array[1..maxvertices] of integer;
    start,eind:integer;
  end;

var
  vertices,geverfd:integer;
  vertex:array[1..maxvertices] of wereld;
  q1,q2:queue;
  runs,run:integer;


Function QEmpty(var q:queue):boolean;
(* var alleen maar omdat het dan een pointer is *)
begin
  QEmpty:=(q.start=q.eind);
end;

Procedure QPush(var q:queue;wnr:integer);
begin
  q.nr[q.eind]:=wnr;
  q.eind:=q.eind+1;
end;

Function QPop(var q:queue):integer;
begin
  if QEmpty(q) then begin
    (* Dan zit je met de gebakken peren *)
    Write('X');
  end else begin
    QPop:=q.nr[q.start];
    q.start:=q.start+1;
  end;
end;


Procedure Init;
var
  buren,nr1,nr2,i:integer;
  pie:pintelt;
begin
  Read(vertices,buren);
  for i:=1 to vertices do begin
    vertex[i].kleur:=[];
    vertex[i].haast:=[];
    vertex[i].genomineerd:=0;
    vertex[i].edge:=NIL;
  end;
  for i:=1 to buren do begin
    Read(nr1,nr2);
    New(pie);
    pie^.index:=nr1;
    pie^.next:=vertex[nr2].edge;
    vertex[nr2].edge:=pie;
    New(pie);
    pie^.index:=nr2;
    pie^.next:=vertex[nr1].edge;
    vertex[nr1].edge:=pie;
  end;
  geverfd:=0;
  (* prepareer queues *)
  q1.start:=1; q1.eind:=1;
  q2.start:=1; q2.eind:=1;
end; { LeesWereld }

Function VerfVertex(wnr:integer):boolean;
var
  result:boolean;
  b:pintelt;
begin
  if (vertex[wnr].haast=[rood,groen,blauw]) then begin
    result:=false;
  end else begin
    result:=true;
    if (rood in vertex[wnr].haast) then begin
      if (groen in vertex[wnr].haast) then begin
	vertex[wnr].kleur:=[blauw];
      end else vertex[wnr].kleur:=[groen];
    end else vertex[wnr].kleur:=[rood];
    vertex[wnr].genomineerd:=2;
    geverfd:=geverfd+1;

    b:=vertex[wnr].edge;
    while (b<>NIL) do begin
      vertex[b^.index].haast:=vertex[b^.index].haast+vertex[wnr].kleur;
      if (vertex[b^.index].haast-vertex[wnr].kleur<>[]) then begin
	(* Heeft ook al een anders gekleurde edge *)
	if (vertex[b^.index].genomineerd<2) then begin
	  (* is zelf nog niet gekleurd, of daarvoor genomineerd, dus: *)
	  QPush(q2,b^.index);
	  vertex[b^.index].genomineerd:=2;
	end;
      end else begin
	if (vertex[b^.index].genomineerd<1) then begin
	  QPush(q1,b^.index);
	  vertex[b^.index].genomineerd:=1;
	end;
      end;
      b:=b^.next;
    end;
  end;
  VerfVertex:=result;
end;

Procedure VervenDieHap;
var
  result:boolean;
  wnr:integer;
begin
  result:=VerfVertex(1); (* levert true op *)
  while result and (geverfd<vertices) do begin
    if QEmpty(q2) then begin
      wnr:=QPop(q1); (* Wastie leeg, dan hadden we geen connected graph *)
      while (vertex[wnr].kleur<>[]) do wnr:=QPop(q1);
      result:=VerfVertex(wnr);
    end else begin
      wnr:=QPop(q2);
      if (vertex[wnr].kleur=[]) then result:=VerfVertex(wnr);
    end;
  end;
  if result then WriteLn('mogelijk') else WriteLn('onmogelijk');
end;


Procedure QuitBuur(b: pintelt);
begin
   if (b<>NIL) then begin
      QuitBuur(b^.next);
      Dispose(b);
   end;
end; { QuitBuur }

Procedure Quit;
var
  i:integer;
begin
  for i:=1 to vertices do QuitBuur(vertex[i].edge);
end; { Quit }


begin
  Read(runs);
  for run:=1 to runs do begin
    Init;
    VervenDieHap;
    Quit;
  end;
end.
