#include <stdlib.h>
#include <stdio.h>

#define maxv 10001

typedef struct vertex {
  long x,y;
} vertex;

typedef vertex vertexarray[maxv];

typedef struct vector {
  int region;
  long dx,dy;
} vector;

typedef vector vectorarray[maxv];

int run,runs;
int c1,c2,c3;
int i1,i2,i3;
vertexarray v3;
vectorarray vec1,vec2;
int comp;

int Compare(vector vec1,vector vec2) {
  int result;
  result=vec2.region-vec1.region;
  if (result==0) result=vec2.dy*vec1.dx-vec1.dy*vec2.dx;
  return(result);
} /* Compare */

void ReadPolygon(int *c,vectorarray vec) {
  vertex v1,prev,v;
  int i;

  scanf(" %d",c);
  scanf(" %ld %ld",&(v1.x),&(v1.y));
  prev.x=v.x=v1.x;
  prev.y=v.y=v1.y;
  for (i=0;i<(*c)-1;i++) {
    scanf(" %ld %ld",&(v.x),&(v.y));
    vec[i].dx=v.x-prev.x;
    vec[i].dy=v.y-prev.y;
    prev.x=v.x; prev.y=v.y;
  }
  vec[(*c)-1].dx=v1.x-v.x;
  vec[(*c)-1].dy=v1.y-v.y;
  for (i=0;i<(*c);i++) {
    if ((vec[i].dy>0) || ((vec[i].dy>=0) && (vec[i].dx>0))) {
      vec[i].region=1;
    } else vec[i].region=2;
  }
  v3[0].x+=v1.x; /* Major       */
  v3[0].y+=v1.y; /* Side effect */
  vec[(*c)].region=4;         /* Sentinel */
} /* ReadPolygon */

int main() {
  scanf(" %d",&runs);
  for (run=1;run<=runs;run++) {
    v3[0].x=0;
    v3[0].y=0;
    ReadPolygon(&c1,vec1);
    ReadPolygon(&c2,vec2);

    i1=0;
    i2=0;
    c3=1;
    while ((i1<c1) || (i2<c2)) {
      comp=Compare(vec1[i1],vec2[i2]);
      if (comp>0) {
        v3[c3].x=v3[c3-1].x+vec1[i1].dx;
        v3[c3].y=v3[c3-1].y+vec1[i1].dy;
        i1=i1+1;
      } else {
        if (comp<0) {
          v3[c3].x=v3[c3-1].x+vec2[i2].dx;
          v3[c3].y=v3[c3-1].y+vec2[i2].dy;
          i2=i2+1;
        } else {
          v3[c3].x=v3[c3-1].x+vec1[i1].dx+vec2[i2].dx;
          v3[c3].y=v3[c3-1].y+vec1[i1].dy+vec2[i2].dy;
          i1=i1+1;
          i2=i2+1;
        }
      }
      c3=c3+1;
    }
    printf("%d\n",c3-1);
    for (i3=0;i3<c3-1;i3++) {
      printf("%ld %ld",v3[i3].x,v3[i3].y);
      if (i3==c3-2) printf("\n"); else printf("  ");
    }
  }
  return(0);
} /* main */
