program RSA (input, output);

const
   digits = 79;
   maxdigit = 81;      { = digits+2 }
   maxtabel = 159;     { = 2*digits +1 }


type
   getal = array[0..maxdigit] of integer;
   { digit 0 is minst significant,
    in principe past de invoer in digits 0..digits,
    maar voor carry e.d. zijn 2 extra digits gereserveerd }
   tabel = array[0..maxtabel] of getal;

var
   n, nruns, run : integer;
   a, b, c, bericht, nul, een : getal;
   macht : tabel;


procedure leesgetal (var x : getal);

var
   ch : char;
   i, j, a : integer;

begin
   a := ord('a');
   { eerste digit op meest significante plaats }
   i := digits;
   while not eoln do begin
      read(ch);
      x[i] := ord(ch)-a;
      i := i-1;
   end;
   readln;
   { naar minder significante plaatsen kopi"eren
    als getal niet de maximale grootte (80 digits) heeft }
   if i>-1 then begin
      for j := i+1 to digits do begin
         x[j-(i+1)] := x[j];
	 x[j] := 0;
      end;
   end;
end; { leesgetal }


function vergelijk (x, y : getal) : integer;
{ post:
     -1, if x<y;
      0, if x=y;
     +1, if x>y
 }

var
   i : integer;
   stop	: boolean;

begin
   i := digits+2;
   repeat
      if (x[i] = y[i]) then begin
	 stop := false;
      end else begin
	 stop := true;
	 if x[i] < y[i] then begin
	    vergelijk := -1;
	 end else begin  { x[i] > y[i] }
	    vergelijk := 1;
	 end;
      end;
      i := i-1;
   until (i<0) or stop;
   if not stop then begin
      vergelijk := 0;
   end;
end; { vergelijk }


procedure trekaf (x, y : getal; var z : getal);
{ pre: x > y
 post: z := x - y }

var
   i, carry : integer;

begin
   carry := 0;
   for i := 0 to digits+2 do begin
      z[i] := x[i] - y[i] - carry;
      if z[i] < 0 then begin
	 z[i] := z[i] + 26;
	 carry := 1;
      end else begin
	 carry := 0;
      end;
   end;
end; { trekaf }


procedure machttabel (n	: getal; var mt : tabel);
{ maakt een tabel mt[i] = 26^i modulo n, i=0..maxdigit-1 }

var
   r, i, j : integer;

begin
   mt[0] := een;
   for r := 1 to (2*digits +1) do begin
      { vermenigvuldig met 26 == shift naar rechts }
      for j := (digits+2) downto 1 do begin
	 mt[r][j] := mt[r-1][j-1];
      end;
      mt[r][0] := 0;
      { doe modulo n }
      while vergelijk(mt[r], n)=1 do begin
	 trekaf(mt[r], n, mt[r]);
      end;
   end;
end; { machttabel }


function deel2 (var x : getal) : boolean;
{ post:
     false, if x = 0 mod 2;
     true,  if x = 1 mod 2
 }

var
   i, j, carry : integer;

begin
   carry := 0;
   for i := digits downto 0 do begin
      x[i] := x[i] + 26*carry;
      carry := x[i] mod 2;
      x[i] := x[i] div 2;
   end;
   deel2 := (carry = 1);
end; { deel2 }


procedure keer (x, y, m : getal; var z : getal);
{ z := x^y modulo m }

var
   i, j, carry : integer;
   conv : array[0..maxtabel] of integer;     { convolutie }

begin
   { convolutieproduct x*y berekenen }
   carry := 0;
   for i := 0 to digits do begin
      conv[i] := carry;
      for j := 0 to i do begin
	 conv[i] := conv[i] + x[j]*y[i-j];
      end;
      carry := conv[i] div 26;
      conv[i] := conv[i] mod 26;
   end;
   for i := (digits+1) to (2*digits) do begin
      conv[i] := carry;
      for j := (i-digits) to digits do begin
	 conv[i] := conv[i] + x[j]*y[i-j];
      end;
      carry := conv[i] div 26;
      conv[i] := conv[i] mod 26;
   end;
   conv[2*digits +1] := carry;
   { hard rekenen! }
   carry := 0;
   for j := 0 to digits do begin
      z[j] := carry;
      for i := 0 to (2*digits +1) do begin
	 z[j] := z[j] + conv[i]*macht[i][j];
      end;
      carry := z[j] div 26;
      z[j] := z[j] mod 26;
   end;
   z[digits+1] := carry;
   { moduleren d.m.v. aftrekken }
   while vergelijk(z, m)=1 do begin
      trekaf(z, m, z);
   end;
end; { keer }


procedure neemmacht (x, y, m : getal; var z : getal);
{ z := x^y mod m }

var
   xtot2toti : getal;

begin
   z := een;
   xtot2toti := x;
   while vergelijk(y, nul)<>0 do begin
      if deel2(y) then begin
	 keer(z, xtot2toti, m, z);
      end;
      keer(xtot2toti, xtot2toti, m, xtot2toti);
   end;
end; { decodeer }


procedure schrijfgetal (x : getal);

var
   i, j, a : integer;

begin
   a := ord('a');
   { zoek meest significante niet-nul-digit op }
   i := digits;
   while (i>=1) and (x[i]=0) do begin
      i := i-1;
   end;
   for j := i downto 0 do begin
      write(chr(x[j]+a));
   end;
   writeln;
end; { schrijfgetal }


begin
   { initialisatie van de constanten }
   for run := 0 to maxdigit do begin
      nul[run] := 0;
   end;
   een := nul;
   een[0] := 1;
   { lees invoer }
   readln(nruns);
   for run := 1 to nruns do begin
      leesgetal(a);
      leesgetal(b);
      leesgetal(c);
      machttabel(a, macht);
      neemmacht(b, c, a, bericht);
      schrijfgetal(bericht);
   end;
end.
