#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define MAXLINES 10000

typedef enum {false,true} boolean;

boolean debug=false;

int c;
int result;

void Quit() {
  fprintf(stderr,"2\n");
  exit(2);
}

boolean ReadChar(int width,char *str) {
  /* Read one char, which should be in str.
     Eat whitespace before, hope these are only real spaces,
     for a total amount of width characters */
  int i=0;
  while (c==' ') {
    i++;
    c=fgetc(stdin);
  }
  if (i!=width-1) result=1;
  while (isspace(c)) {
    result=1;
    c=fgetc(stdin);
  }
  if (strchr(str,c)==NULL) Quit();
  c=fgetc(stdin);
  return(result);
}

boolean ReadNumber(int width,boolean remember) {
  /* Read a number, maximum max, preceded by spaces,
     so exactly width charcters should be read */
  long nr;
  static long whereami=-1;
  static boolean first=true;
  int i,j; 
  i=0;
  while (c==' ') {
    if (debug) fprintf(stderr,"_");
    i++;
    c=fgetc(stdin);
  }
  while (isspace(c)) {
    result=1;
    c=fgetc(stdin);
  }
  j=0;
  nr=0;
  while ((j<width) && (isdigit(c))) { /* j<width is secure for overflow of nr */
    j++;
    nr=nr*10+c-'0';  /* ASCII-only */
    if (debug) fprintf(stderr,"[%d,%d,%ld]",i,j,nr);
    if ((nr==0)&&(j!=1)) Quit();
    c=fgetc(stdin);
  }
  if (j==0) Quit();
  if (nr>=MAXLINES) Quit();
  if (i+j!=width) result=1;
  if (remember) {
    if (first) {
      first=false;
      if (nr!=0) Quit();
    }
    if (nr!=whereami+1) Quit();
    whereami++;
  }
  return(result);
}

boolean ReadLn() {
  /* Read a newline */
  if (c=='\n') { /* UNIX only */
    c=fgetc(stdin);
  } else {
    while (isspace(c)) c=fgetc(stdin);
    result=1;
  }
  return(result);
}

int main() {
  int i;
  c=fgetc(stdin);
  ReadChar(2,"q");
  ReadChar(7,"a"); /* dus niet 6, Meinte */
  ReadChar(7,"b");
  ReadChar(7,"c");
  ReadChar(7,"d");
  ReadChar(7,"e");
  ReadChar(7,"f");
  ReadChar(7,"g");
  ReadChar(7,"~");
  ReadLn();
  while (c!='*') {
    ReadNumber(4,true);
    /* Deze moeten achtereenvolgens in oplopende volgorde... */
    for (i=0;i<8;i++) {
      ReadNumber(5,false);
      ReadChar(1,"abcdefg~");
      ReadChar(1,"LR.h");
    }
    ReadLn();
  }
  if (result==1) fprintf(stderr,"1\n");
  if (result>1) fprintf(stderr,"Turing Syntax Checker in de war\n");
  return(result);
}
