$GLOBAL 'NONE'$
Program Turing(input,output);

(* Turing Compiler, compiles specific NKP'97 language into Turing-code *)

(* Procedures which scan and parse also produce output *)

const
  maxregel=9999;

type
  trans=record
    newstate:integer;
    newsym:char;
    newdir:char;
  end;
  transitie=record
    regel:array[1..8] of trans;
  end;
  commset=(ondir,onanywrite,onfalsedo);

var
  alfabet:array[1..8] of char;
  getal:array[char] of integer;
  sym:char;
  nextstate:integer;
  functie:array[0..maxregel] of transitie;
  i:integer;
  somestate:integer;
  somefunc:commset;
  somesym:char;


Procedure NextSym;
begin
  while EoLn do ReadLn;
  Read(sym);
  while (sym=' ') do begin
    if EoLn then ReadLn else Read(sym);
  end;
end; { NextSym }


Procedure Dir(var state:integer;var func:commset;var symbol:char); forward;
Procedure SchrijfSchuif(var state:integer;var func:commset;var symbol:char); forward;
Procedure TestExec(var state:integer;var func:commset;var symbol:char); forward;
Procedure Instr(var state:integer;var func:commset;var symbol:char); forward;


Procedure Dir;
var
  mystate,i:integer;
begin
  mystate:=nextstate;
  nextstate:=nextstate+1;
  for i:=1 to 8 do with functie[mystate].regel[i] do begin
    newstate:=nextstate;
    newsym:=alfabet[i];
    newdir:=sym;
  end;
  symbol:=sym;
  state:=mystate;
  func:=ondir;
  NextSym;
end; { Dir }

Procedure SchrijfSchuif;
var
  mystate:integer;
  mysym:char;
  i:integer;
begin
  mystate:=nextstate;
  nextstate:=nextstate+1;
  NextSym; (* '(' *)
  NextSym; (* <symb> *)
  mysym:=sym;
  NextSym; (* ',' *)
  NextSym; (* <dir> *)
  for i:=1 to 8 do with functie[mystate].regel[i] do begin
    newstate:=nextstate;
    newsym:=mysym;
    newdir:=sym;
  end;
  NextSym; (* ')' *)
  state:=mystate;
  func:=onanywrite;
  symbol:=mysym;
  NextSym;
end; { SchrijfSchuif }

Procedure TestExec;
var
  mystate,prevstate:integer;
  prevfunc:commset;
  mysym,prevsym:char;
  i:integer;
begin
  mystate:=nextstate;
  nextstate:=nextstate+1;
  for i:=1 to 8 do with functie[mystate].regel[i] do begin
    newstate:=nextstate;
    newsym:=alfabet[i];
    newdir:='.';
  end;
  NextSym; (* '(' *)
  NextSym; (* <symb> *)
  mysym:=sym;
  NextSym; (* ',' *)
  NextSym; (* begin <frag> *)
  case sym of
    'L','R','h','.': Dir(prevstate,prevfunc,prevsym);
    'w': SchrijfSchuif(prevstate,prevfunc,prevsym);
    'l': TestExec(prevstate,prevfunc,prevsym);
  end;
  while (sym=';') do begin
    NextSym;
    Instr(prevstate,prevfunc,prevsym);
  end;
  functie[mystate].regel[getal[mysym]].newstate:=nextstate;
  if (prevfunc=onfalsedo) then begin
    functie[prevstate].regel[getal[prevsym]].newstate:=mystate;
  end else begin
    with functie[prevstate] do for i:=1 to 8 do regel[i].newstate:=mystate;
  end;
  state:=mystate;
  func:=onfalsedo;
  symbol:=mysym;
  NextSym;
end; { TestExec }

Procedure Instr;
begin
  case sym of
    'L','R','h','.': Dir(state,func,symbol);
    'w': SchrijfSchuif(state,func,symbol);
    'l': TestExec(state,func,symbol);
  end; { case }
end;


Procedure Print;
var
  i,s:integer;
begin
  Write(' q');
  for i:=1 to 8 do begin
    Write(alfabet[i]:7);
  end;
  WriteLn;
  for s:=0 to nextstate do begin
    Write(s:4);
    for i:=1 to 8 do with functie[s].regel[i] do begin
      Write(newstate:5,newsym:1,newdir:1);
    end;
    WriteLn;
  end;
  WriteLn('*');
end; { Print }


begin
  (* Init *)
  alfabet[1]:='a';    alfabet[2]:='b';
  alfabet[3]:='c';    alfabet[4]:='d';
  alfabet[5]:='e';    alfabet[6]:='f';
  alfabet[7]:='g';    alfabet[8]:='~';
  getal['a']:=1;    getal['b']:=2;
  getal['c']:=3;    getal['d']:=4;
  getal['e']:=5;    getal['f']:=6;
  getal['g']:=7;    getal['~']:=8;

   NextSym;
   nextstate:=0;
   (* Run *)
   while (sym<>'!') do begin
     Instr(somestate,somefunc,somesym);
     if (sym=';') then NextSym;
   end;
   (* Finish off *)
   for i:=1 to 8 do with functie[nextstate].regel[i] do begin
      newstate:=nextstate;
      newsym:=alfabet[i];
      newdir:='h';
   end;
   (* Print *)
   Print;
end.
