/*
   (c) 15/09/'97 Meinte Boersma
   (a) 08/10/'97 Meinte Boersma
   C-uitwerking van de NKP'97-opgave "Jurassic Park"
*/

#include <stdio.h>

#define max 50000

typedef int prefix[max+1];
typedef char sequence[max+2];


void computePrefixFunction (int m, sequence P, prefix pi)
{
  int k = 0, q;

  pi[1] = 0;
  for (q=2; q<=m; q++) {
    while ((k>0) && (P[k+1] != P[q])) {
      k = pi[k];
    }
    if (P[k+1] == P[q]) {
      k++;
    }
    pi[q] = k;
  }
}


int KMPoccurrences (int n, int m, sequence P, prefix pi)
{
  char ch;
  int q = 0, matches = 0, i;

  for (i=1; i<=n; i++) {
    scanf("%c", &ch);   /* ch == T[i] */
    while ((q>0) && (P[q+1] != ch)) {
      q = pi[q];
    }
    if (P[q+1] == ch) {
      q++;
    }
    if (q == m) {
      matches++;
      q = pi[q];
    }
  }
  return matches;
}


void match (int m, sequence P, prefix pi)
{
  int n, matches;
  int nruns, run;
  int maxmatches, optimum, length;

  /* read #texts */
  scanf("%d", &nruns);
  /* read first text */
  scanf("%d", &n);
  scanf("\n");
  maxmatches = KMPoccurrences(n, m, P, pi);
  optimum = 1;
  length = n;
  /* read next texts */
  for (run=2; run<=nruns; run++) {
    scanf("%d\n", &n);
    matches = KMPoccurrences(n, m, P, pi);
    if ((matches>maxmatches) || ((matches==maxmatches) && (n<length))) {
       maxmatches = matches;
       optimum = run;
       length = n;
     }
  }
  printf("%d %d\n", optimum, maxmatches);
}


int main (void)
{
  int m;
  prefix pi;
  sequence TrexDNA;

  /* read pattern and calculate prefix-table */
  scanf("%d\n", &m);
  fgets(TrexDNA+1, m+1, stdin);
  computePrefixFunction(m, TrexDNA, pi);
  match(m, TrexDNA, pi);

  /* exit */
  return(0);
}
