/*
   na\"ieve version for JurassicPark
   (c) 12/10/'97 by Meinte Boersma for NKP'97
*/

#include <stdio.h>

#define max 50000

#define debug_info 1
#define debug_ratio 2

typedef char sequence[max+1];

typedef enum { false, true } boolean;


int naieve (int n, int m, sequence P)
{
  int pointer, offset;
  int nmatches, i;
  sequence buffer;     /* circular buffer */
  boolean match;

  /* read first m characters of text T */
  for (i=0; i<m; i++) {
    fscanf(stdin, "%c", &buffer[i]);
  }
  pointer = 0;
  nmatches = 0;
  /* actual portion of T stored in buffer[pointer%max..(pointer+m-1)%max] */
  for (i=0; i<=(n-m); i++) {
    if (i%1000==0) {
      printf("i=%d\n", i);
    }
    match = true;
    offset = 0;
    while (match && (offset<m)) {
      match = (P[offset]==buffer[(pointer+offset)%max]);
      offset++;
    }
    if (match) {
#if debug_info
      printf("match occurred at *%d*\n", i);
#endif
      nmatches++;
    } else {
#if debug_info
      if (offset>(m/debug_ratio)) {
	printf("near-match occurred at *%d* of *%d* characters\n", i, (offset-1));
      }
#endif
    }
    if (i<n-m) {
      fscanf(stdin, "%c", &(buffer[(pointer+m)%max]));
      pointer++;
    }
  }
  fscanf(stdin, "\n");
  return (nmatches);
}


void match (int m, sequence P)
{
  int n;
  int nruns, runs, matches;
  int maxmatches, optimum, length;

  scanf("%d\n", &nruns);
  maxmatches = 0;
  length = 500000001;   /* > max(length) */
  for (runs=1; runs<=nruns; runs++) {
    scanf("%d\n", &n);
    matches = naieve(n, m, P);
#if debug_info
    printf("run %d: %d matches\n", runs, matches);
#endif
    if ((matches>maxmatches) || ((matches==maxmatches) && (n<length))) {
      maxmatches = matches;
      optimum = runs;
      length = n;
    }
  }
  printf("%d %d\n", optimum, maxmatches);
}


int main (void)
{
  int m;
  sequence P;

  fscanf(stdin, "%d\n", &m);
  fscanf(stdin, "%s\n", P);
  match(m, P);

  return(0);
}
