program DNA (input, output);

{ (c) 13/09/'97 Meinte Boersma
  Pascal-uitwerking van de NKP'97-opgave "Jurassic Park"
}

const
   max = 50000;

type
   prefix = array[1..max] of integer;
   sequence = array[1..max] of char;

var
   ch : char;
   pi : prefix;
   TrexDNA : sequence;
   m, i : integer;

{ subsequently "var" is used to avoid copying large
  datastructures such as DNA-sequences }

procedure computePrefixFunction (m : integer; var P : sequence;
                                              var pi : prefix);

var
   k, q : integer;

begin
   k := 0;
   pi[1] := 0;
   for q := 2 to m do begin
      while (k > 0) and (P[k+1] <> P[q]) do  k := pi[k];
      if P[k+1] = P[q] then begin
         k := k + 1;
      end;
      pi[q] := k;
   end;
end; { computePrefixFunction }


function KMPoccurences (n, m : integer; var P : sequence;
                                        var pi : prefix) : integer;

var
   ch : char;
   q, matches, i : integer;

begin
   q := 0;
   matches := 0;
   for i := 1 to n do begin
      read(ch);   { ch = T[i] }
      while (q > 0) and (P[q+1] <> ch) do begin
         q := pi[q];
      end;
      if P[q+1] = ch then begin
         q := q + 1;
      end;
      if q = m then begin
         matches := matches + 1;
         q := pi[q];
      end;
   end;
   KMPoccurences := matches;
end; { KMPoccurences }


function choice (m : integer; P : sequence; pi : prefix) : integer;

var
   n, t, optimum, matches, maxmatches, length, i : integer;

begin
   { read #texts t }
   readln(t);
   { read first text }
   readln(n);
   maxmatches := KMPoccurences(n, m, TrexDNA, pi);
   optimum := 1;
   length := n;
   { read next texts }
   for i := 2 to t do begin
      readln(n);
      matches := KMPoccurences(n, m, TrexDNA, pi);
      if (matches>maxmatches) or ((matches=maxmatches) and (n<length)) then begin
         maxmatches := matches;
         optimum := i;
         length := n;
      end;
   end;
   choice := optimum;
end; { choice }


begin
   { read pattern and calculate prefix-tabel }
   readln(m);
   for i := 1 to m do begin
      read(ch);
      TrexDNA[i] := ch;
   end;
   computePrefixFunction(m, TrexDNA, pi);
   writeln(choice(m, TrexDNA, pi):1);
end.
